unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    ProgressBar1: TProgressBar;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 i:Integer;
begin
 for i:=0 to 20 do
  begin
   //Здесь можно делать какой-то расчёт

   //После расчёта отображаем текущее состояние
   ProgressBar1.Position:=ProgressBar1.Position+5;
   Sleep(100);
  end;
 ProgressBar1.Position:=0;
end;

end.
